-- fichier ts_bounded.adb
-- T.Avignon & D.Feneuille
-- octobre 2000
-- TP 12A
--
-- Utilisation de P_Bounded_80 et de P_Bounded_80_Io
-- P_Bounded_80 est construit   partir du paquetage gnrique 
-- Generic_Bounded_Length contenu dans Ada.Strings.Bounded
-- P_Bounded_80 permet la manipulations de Bounded_String de longueur
-- maximale fixe  80 caractres. 
-- P_Bounded_80_Io est un paquetage permettant la lecture et
-- l'criture de chane de type Bounded_String
-- La procdure Ts_Bounded utilise les fonctionnalits contenues 
-- dans P_Bounded_80

with P_Bounded_80;               use P_Bounded_80;
with P_Bounded_80_Io;            use P_Bounded_80_Io;
with Ada.Text_Io;                use Ada.Text_Io;  

with Ada.Strings.Maps.Constants; use Ada.Strings.Maps.Constants; 
                                 use Ada.Strings;
                                 use Ada.Strings.Maps;

procedure Ts_Bounded is 

   package P_Entier is new Ada.Text_Io.Integer_Io(Natural);
   use P_Entier;

   Bs1,  
   Bs2,  
   Bs3 : Bounded_String;  
   Ch1 : String (1 .. 80);  
   L1  : Natural;  
   C1  : Character;  

begin
   -- test de la fonction LENGTH

   New_Line(2);
   Put("Saisie de la chane pour tester LENGTH: ");
   Bs1:=Get_Line;
   Put("Affichage de la chaine : ");
   Put_Line (Bs1);
   Put("Nombre de caractres de la chaine : ");
   Put(Length(Bs1));
   New_Line;

   -- tests des fonctions de conversion
   -- STRING to  BOUNDED_STRING et BOUNDED_STRING to STRING

   Put("Saisie de la chane BOUNDED pour tester T0_STRING  ");
   Bs2:= Get_Line;
   New_Line;
   Put("Affichage de la chane STRING ");
   Put_Line(To_String(Bs2));
   New_Line;
   Put("Saisie d'une chane STRING pour tester TO_BOUNDED_STRING  ");
   Get_Line(Ch1, L1);
   Put("Affichage de la chane BOUNDED ");
   Put_Line(To_Bounded_String(Ch1(1..L1)));
   New_Line;

   -- tests des fonctions de concatnation "&" et APPEND

   Put("Saisie de la premire chane BOUNDED pour tester & et APPEND ");
   Bs1:=Get_Line;
   New_Line;
   Put("Saisie de la deuxime chane BOUNDED pour tester & et APPEND  ");
   Bs2:=Get_Line;
   New_Line;
   Bs3 :=  Bs1  & ' ' &  Bs2;
   Put("Affichage de la concatnation avec & des deux chanes ");
   Put_Line(Bs3);
   Append(Bs1,Bs2);
   Put("Affichage de la concatnation avec APPEND des deux chanes ");
   Put_Line (Bs1);

   -- tests des fonctions de slection ELEMENT, REPLACE_ELEMENT,SLICE
   -- REPLACE_SLICE 

   Put ("Saisie d'une chane BOUNDED pour tester ELEMENT ");
   Put_Line(" REPLACE_ELEMENT, SLICE et REPLACE_SLICE  ");
   Bs1:=Get_Line;
   Put("Extraction du 5 ime lment ");
   C1 := Element (Bs1,5);
   Put(C1);
   New_Line;

   Put("Remplacement du 5 ime lment par 'A' ");
   Replace_Element(Bs1,5,'A');
   Put_Line(Bs1);

   Put("Extraction des caractres des positions 2  5 ");
   Bs2 := To_Bounded_String(Slice(Bs1,2,5));
   Put_Line(Bs2);

   Put("Remplacement des caractres de 2  5 par la chane ""ABCDE""   ");
   Bs2 := Replace_Slice(Bs1,2,5,"ABCDE");
   Put_Line(Bs2);

   -- test d'une fonction de comparaison  ex: <=  

   Put("Saisie d'une premire chane pour tester  <= ");
   Bs1:=Get_Line;
   New_Line;
   Put("Saisie d'une deuxime chane pour tester <= ");
   Bs2:=Get_Line;
   New_Line;
   if Bs1 <= Bs2
         then
      Put("La chane ");
      Put(Bs1);
      Put(" est plus petite ou gale  ");
      Put_Line(Bs2);
   else
      Put("La chane ");
      Put(Bs1);
      Put(" est plus grande que la chane ");
      Put_Line(Bs2);
   end if;

   -- tests des autres fonctions de slection INDEX et COUNT 

   Put("Saisie d'une chane pour tester INDEX ");
   Bs1:= Get_Line;
   New_Line;
   Put("Saisie d'une sous-chane pour tester INDEX ");
   Bs2:=Get_Line;
   L1 := Index(Bs1, To_String(Bs2), Forward,Upper_Case_Map);
   if L1 > 0
         then
      Put("La sous-chane est trouve en position ");
      Put(L1);
      New_Line;
   else
      Put("La sous-chane n'est pas trouve ");
      New_Line;
   end if;
   Put("Saisie d'une chane pour tester COUNT ");
   Bs1:=Get_Line;
   New_Line;
   Put("Saisie d'une sous-chane pour tester COUNT ");
   Bs2:=Get_Line;
   Put("Transformation de la sous-chane en majuscules ");
   Bs2 := Translate (Bs2,Upper_Case_Map);
   Put_Line( Bs2);
   L1 := P_Bounded_80.Count(Bs1, To_String(Bs2), Upper_Case_Map);
   -- il faut qualifier car COUNT est galement un sous-type de ADA.TEXT_IO
   if L1 > 0
         then
      Put("La sous-chane est prsente ");
      Put(L1);
      Put(" FOIS ");
      New_Line;
   else
      Put("La sous-chane n'est pas trouve ");
      New_Line;
   end if;

   -- test de la fonction de conversion TRANSLATE
   Put("Affichage de ADA95 en minuscules (test de TRANSLATE) ");
   Bs1:= Translate(To_Bounded_String("ADA95"),Lower_Case_Map);
   Put_Line(Bs1);
   Put("Affichage de ""prffini"" sans accents (test de translate) ");
   Bs1:= Translate(To_Bounded_String("prdfini"),Basic_Map);
   Put_Line(Bs1);

   -- tests des fonctions de transformation INSERT, DELETE et OVERWRITE

   Put("Saisie d'une chane pour tester INSERT ");
   Bs1:=Get_Line;
   New_Line;
   Put("Saisie d'une sous-chane pour tester INSERT ");
   Bs2:=Get_Line;
   New_Line;
   Insert (Bs1, 3, To_String (Bs2),Right);
   Put("Affichage de la nouvelle chane aprs INSERT ");
   Put_Line(Bs1);

   Put("Saisie d'une chane pour tester DELETE ");
   Bs1:=Get_Line;
   New_Line;
   Delete (Bs1,2,4);
   Put("Affichage de la nouvelle chane aprs DELETE ");
   Put_Line(Bs1);

   Put("Saisie d'une chane pour tester OVERWRITE ");
   Bs1:=Get_Line;
   New_Line;
   Put("Saisie d'une sous-chane pour tester OVERWRITE ");
   Bs2:=Get_Line;
   New_Line;
   Overwrite (Bs1,3,To_String(Bs2),Right);
   Put("Affichage de la nouvelle chane aprs OVERWRITE ");
   Put_Line(Bs1);

   -- tests d'autres  fonctions d'extraction TRIM, HEAD et TAIL


   Put("Saisie d'une chane pour tester TRIM ");
   Bs1:=Get_Line;
   New_Line;
   Bs1:= "123" & Bs1 & "456";
   Put("Affichage de la chane avec des chiffres  en tte et en queue ");
   Put_Line (Bs1);
   Put("Suppression des chiffres en tte et en queue ");
   Trim (Bs1,Left => Decimal_Digit_Set,Right=> Decimal_Digit_Set);
   Put("Affichage de la nouvelle chane aprs TRIM ");
   Put_Line(Bs1);

   Put("Saisie d'une chane pour tester HEAD ");
   Bs1:=Get_Line;
   New_Line;
   Bs1:= Head(Bs1,3);
   Put(
      "Affichage de la nouvelle chane aprs HEAD pour les 3 premiers caractres  ");
   Put_Line(Bs1);

   Put("Saisie d'une chane pour tester TAIL ");
   Bs1:=Get_Line;
   New_Line;
   Bs1:= Tail(Bs1,3);
   Put(
      "Affichage de la nouvelle chane aprs TAIL pour les 3 derniers cactres   ");
   Put_Line(Bs1);

   -- tests des fonctions de cration de chanes  "*" et REPLICATE

   Put("Saisir un caractre pour tester la fonction ""*"" ");
   Get(C1);
   New_Line;
   Skip_Line;
   Put("Cration d'une chane de 10 caractres 'a' ");
   Bs1 := 10 * C1;
   Put ("Affichage de la chane obtenue ");
   Put_Line (Bs1);

   Put("Saisir une chane pour tester REPLICATE ");
   Bs1:=Get_Line;
   New_Line;
   Bs1:= Replicate(3,To_String(Bs1));
   Put("Affichage de la chane cre : ");
   Put_Line(Bs1);

end Ts_Bounded;