-- fichier P_PILE_4.adb
-- D.Feneuille & T.Avignon   Octobre 2000
-- pour TD-TP

with Ada.Exceptions;
use  Ada.Exceptions;

package body P_Pile_4 is

   procedure Empiler (Une_Pile : in out T_Pile;
         Elem : in T_Elem) is
   begin
      if Une_Pile.Sommet = Une_Pile.Le_Max
            then Raise_Exception ( Exc_Pile_Pleine'Identity, "Empiler ");
      end if;
      Une_Pile.Sommet := Une_Pile.Sommet + 1;
      Une_Pile.V (Une_Pile.Sommet) := Elem;
   end Empiler;

   procedure Depiler (Une_Pile : in out T_Pile;
         Elem : out T_Elem) is
   begin
      if Une_Pile.Sommet = 0
            then Raise_Exception ( Exc_Pile_Vide'Identity, "Dpiler ");
      end if;
      Une_Pile.Sommet := Une_Pile.Sommet - 1;
      Elem := Une_Pile.V (Une_Pile.Sommet + 1);
   end Depiler;

   function Pile_Vide (Une_Pile : in T_Pile) return Boolean is
   begin
      return Une_Pile.Sommet = 0;
   exception
      when others => Raise_Exception( Exc_Pile_Erreur'Identity, "Pile Vide ");
   end Pile_Vide;

   function Pile_Pleine (Une_Pile : in T_Pile) return Boolean is
   begin
      return Une_Pile.Sommet = Une_Pile.Le_Max;
   exception
      when others => Raise_Exception( Exc_Pile_Erreur'Identity, "Pile Pleine ");
   end Pile_Pleine;

   function Haut_Pile (Une_Pile: in T_Pile) return T_Elem is
   begin
      return Une_Pile.V(Une_Pile.Sommet);
   exception
      when Constraint_Error => Raise_Exception( Exc_Pile_Vide'Identity,
            " Haut de Pile ");
   end Haut_Pile;

   function Hauteur (Une_Pile : in T_Pile) return Natural is
   begin
      return Une_Pile.Sommet;
   end Hauteur;

end P_Pile_4;
